/////////////////////////////////////////////////////////////////
//Copyright (C) 2005 NTT CORPORATION.
//
//	ԃNX
//
//		ύX
//			2005.02.16  VK쐬  Katsuhiko.Sakurai(UNITEC)
//
//	@\
//
//	̃NX͊ԃNXłB
//
////////////////////////////////////////////////////////////////
package jp.co.ntt.lms.lo.progress.util;

import java.text.MessageFormat;

import jp.co.ntt.lms.xmo.util.DebugLog;


/**
 * ԃNXłB
 * 
 * @author Katsuhiko Sakurai (UNITEC)
 * @version 1.0
 */
public class TimeSpan {
	
	private int years = 0;
	private int months = 0;
	private int days =0;
	private int hours = 0;
	private int minutes = 0;
	private int seconds = 0;
	
	/**
	 * RXgN^łB
	 * 
	 */
	public TimeSpan(){}
	
	/**
	 * RXgN^łB
	 * 
	 * @param years N
	 * @param months 
	 * @param days 
	 * @param hours Ԑ
	 * @param minutes 
	 * @param seconds b
	 */
	public TimeSpan(int years, int months, int days, int hours, int minutes, int seconds) {
		this.years = years;
		this.months = months;
		this.days = days;
		this.hours = hours;
		this.minutes = minutes;
		this.seconds = seconds;
	}
	
	/**
	 * 擾܂B
	 * 
	 * @return int 
	 */
	public int getDays() {
		return this.days;
	}

	/**
	 * ݒ肵܂B
	 * 
	 * @param days 
	 */
	public void setDays(int days) {
		this.days = days;
	}

	/**
	 * Ԑ擾܂B
	 * 
	 * @return int Ԑ
	 */
	public int getHours() {
		return this.hours;
	}
	
	/**
	 * Ԑݒ肵܂B
	 * 
	 * @param hours Ԑ
	 */
	public void setHours(int hours) {
		this.hours = hours;
	}

	/**
	 * 擾܂B
	 * 
	 * @return int 
	 */
	public int getMinutes() {
		return this.minutes;
	}
	
	/**
	 * ݒ肵܂B
	 * 
	 * @param minutes 
	 */
	public void setMinutes(int minutes) {
		this.minutes = minutes;
	}

	/**
	 * 擾܂B
	 * 
	 * @return int 
	 */
	public int getMonths() {
		return this.months;
	}
	
	/**
	 * ݒ肵܂B
	 * 
	 * @param months 
	 */
	public void setMonths(int months) {
		this.months = months;
	}

	/**
	 * b擾܂B
	 * 
	 * @return int b
	 */
	public int getSeconds() {
		return this.seconds;
	}

	/**
	 * bݒ肵܂B
	 * 
	 * @param seconds b
	 */
	public void setSeconds(int seconds) {
		this.seconds = seconds;
	}

	/**
	 * N擾܂B
	 * 
	 * @return int N
	 */
	public int getYears() {
		return this.years;
	}

	/**
	 * Nݒ肵܂B
	 * 
	 * @param years N
	 */
	public void setYears(int years) {
		this.years = years;
	}

	/**
	 * w肳ꂽԂɕϊ܂B
	 * 
	 * @param iso8601String ISO8601`̊Ԃ\
	 * @return TimeSpan 
	 * @throws Exception
	 */
	public static TimeSpan parseTimeSpan(String iso8601String) throws Exception {

		String years = "0000";
		String months = "00";
		String days = "00";
		String hours = "00";
		String minutes = "00";
		String seconds = "00";
		
		// go
		String[] durationStringSplit = iso8601String.split("P");
		if (durationStringSplit.length < 2) return null;
		
		String contents = durationStringSplit[1];
		
		// `ƂɃtH[}bgϊ
		// @P1Y2M3DT4H5M6S `
		if ( contents.matches(".*(Y|M|D|H|S).*") ) {
			
			// tƎԕ𕪊
			String[] splitString = contents.split("T");
			String datePart = splitString[0];
			String timePart = "";
			if (splitString.length > 1) {
				timePart = splitString[1];
			}
			
			// t̏
			// N
			if (datePart.indexOf("Y") > 0) {
				years = datePart.substring(0, datePart.indexOf("Y"));
				datePart = datePart.substring(datePart.indexOf("Y")+1);
			}
			
			// 
			if (datePart.indexOf("M") > 0) {
				months = datePart.substring(0, datePart.indexOf("M"));
				datePart = datePart.substring(datePart.indexOf("M")+1);
			}
			
			// 
			if (datePart.indexOf("D") > 0) {
				days = datePart.substring(0, datePart.indexOf("D"));
			}
			
			// ԕ̏
			if (timePart.length() > 0) {
			
				// Ԑ
				if (timePart.indexOf("H") > 0) {
					hours = timePart.substring(0, timePart.indexOf("H"));
					timePart = timePart.substring(timePart.indexOf("H")+1);
				}
				
				// 
				if (timePart.indexOf("M") > 0) {
					minutes = timePart.substring(0, timePart.indexOf("M"));
					timePart = timePart.substring(timePart.indexOf("M")+1);
				}
				
				// b
				if (timePart.indexOf("S") > 0) {
					seconds = timePart.substring(0, timePart.indexOf("S"));
				}
			}
			
		// @P0001-12-04T10:10:10 `
		} else if ( contents.matches(".*(-|:).*")) {

			// tƎԕ𕪊
			String[] splitString = contents.split("T");
			String datePart = splitString[0];
			String timePart = "";
			if (splitString.length > 1) {
				timePart = splitString[1];
			}
			
			// t̏
			String[] splitDatePart = datePart.split("-");
			
			switch (splitDatePart.length) {
			case 3:
				years = splitDatePart[0];
				months = splitDatePart[1];
				days = splitDatePart[2];
				break;
				
			case 2:
				years = splitDatePart[0];
				months = splitDatePart[1];
				break;
				
			default:
				break;
			} 
			
			// ԕ̏
			if (timePart.length() > 0) {
			
				String[] splitTimePart = timePart.split(":");
				
				switch (splitTimePart.length) {
				case 3:
					hours = splitTimePart[0];
					minutes = splitTimePart[1];
					seconds = splitTimePart[2];
					break;
					
				case 2:
					hours = splitTimePart[0];
					minutes = splitTimePart[1];
					break;
					
				default:
					break;
				} 
			}
			
		
		// @P00011204T101010 `
		} else {

			// tƎԕ𕪊
			String[] splitString = contents.split("T");
			String datePart = splitString[0];
			String timePart = "";
			if (splitString.length > 1) {
				timePart = splitString[1];
			}
			
			if(datePart.length() == 8) {
				years = datePart.substring(0, 4);
				months = datePart.substring(4, 6);
				days = datePart.substring(6, 8);

			} else if(datePart.length() == 6) {
				years = datePart.substring(0, 2);
				months = datePart.substring(2, 4);
				days = datePart.substring(4, 6);
			} 

			if (timePart.length() > 0) {
				hours = timePart.substring(0, 2);
				minutes = timePart.substring(2, 4);
				seconds = timePart.substring(4, 6);
			}
		}
		
		// ϊԂ\
		final String convertedDateString = 
					MessageFormat.format("{0}-{1}-{2}T{3}:{4}:{5}",
							new String[]{years, months, days, hours, minutes, seconds});
	
		DebugLog.write(TimeSpan.class,"ϊ̊wK:" + convertedDateString, DebugLog.ROW);
		
		return new TimeSpan(Integer.parseInt(years),
								Integer.parseInt(months), 
								Integer.parseInt(days), 
								Integer.parseInt(hours), 
								Integer.parseInt(minutes), 
								Integer.parseInt(seconds));
	}
	
}
