/*
--	CopyRight(C) 2003，NTT All rights reserved
--
--  XMS2データベースINDEXの作成
--
--	スクリプト概要

--		XMS2データベースのINDEXを新規に作成します

--
--	変更履歴
--		2004.01.08 新規作成 箕輪英司
--
*/

-- AICCCOMMENTテーブル
CREATE INDEX AICCCOMMENT_INDEX_1
ON AICCCOMMENT
(USERID);

CREATE INDEX AICCCOMMENT_INDEX_2
ON AICCCOMMENT
(LOID);

-- AICCCOREテーブル
CREATE INDEX AICCCORE_INDEX_1
ON AICCCORE
(USERID);

CREATE INDEX AICCCORE_INDEX_2
ON AICCCORE
(LOID);

-- AICCINTERACTIONテーブル
CREATE INDEX AICCINTERACTION_INDEX_1
ON AICCINTERACTION
(USERID);

CREATE INDEX AICCINTERACTION_INDEX_2
ON AICCINTERACTION
(LOID);

-- AICCOBJECTIVESテーブル
CREATE INDEX AICCOBJECTIVES_INDEX_1
ON AICCOBJECTIVES
(USERID);

CREATE INDEX AICCOBJECTIVES_INDEX_2
ON AICCOBJECTIVES
(LOID);

-- ASSIGNMENTSテーブル
CREATE INDEX Assignments_Index_1
ON Assignments
(memberShipID, materialID);

CREATE INDEX ASSIGNMENTS_INDEX_2
ON ASSIGNMENTS
(MEMBERSHIPID);

-- CATALOGLOテーブル
CREATE INDEX CATALOGLO_INDEX_1
ON CATALOGLO
(LOID);

-- CATALOGLO_LOLISTテーブル
CREATE INDEX CATALOGLO_LOLIST_INDEX_1
ON CATALOGLO_LOLIST
(LOID);

-- CONFERENCELOテーブル
CREATE INDEX CONFERENCELO_INDEX_1
ON CONFERENCELO
(LOID);

-- EVALUATEテーブル
CREATE INDEX EVALUATE_INDEX_1
ON EVALUATE
(USER_ID);

CREATE INDEX EVALUATE_INDEX_2
ON EVALUATE
(LOID);

-- EXCHANGELOテーブル
CREATE INDEX EXCHANGELO_INDEX_1
ON EXCHANGELO
(LOID);

-- FACE2FACELOテーブル
CREATE INDEX FACE2FACELO_INDEX_1
ON FACE2FACELO
(LOID);

-- GROUPANDPEOPLEテーブル
CREATE INDEX GroupAndPeople_Index_1
ON GroupAndPeople
(memberShipID);

CREATE INDEX GroupAndPeople_Index_2
ON GroupAndPeople
(parentID);

CREATE INDEX GroupAndPeople_Index_3
ON GroupAndPeople
(childID);

-- GROUPSテーブル
CREATE INDEX Groups_Index_1
ON Groups
(group_id);

-- LAUNCHFORGETLOテーブル
CREATE INDEX LAUNCHFORGETLO_INDEX_1
ON LAUNCHFORGETLO
(LOID);

-- LOテーブル
CREATE INDEX LO_Index_1
ON LO
(LOID);

CREATE INDEX LO_INDEX_2
ON LO
(REALLOID);

-- LOHISTORYテーブル
CREATE INDEX LOHISTORY_INDEX_1
ON LOHISTORY
(LOID);

-- LOLOGテーブル
CREATE INDEX LOLog_Index_1
ON LOLog
(UserID);

CREATE INDEX LOLog_Index_2
ON LOLog
(LOID);

-- LOLOGSESSIONテーブル
CREATE INDEX LOLOGSESSION_INDEX_1
ON LOLOGSESSION
(USERID);

CREATE INDEX LOLOGSESSION_INDEX_2
ON LOLOGSESSION
(LOID);

-- LORELATIONテーブル
CREATE INDEX LORelation_Index_1
ON LORelation
(parentID);

CREATE INDEX LORELATION_INDEX_2
ON LORELATION
(MATERIALID);

CREATE INDEX LORELATION_INDEX_3
ON LORELATION
(CHILDID);

-- LOTYPEテーブル
CREATE INDEX LOTYPE_INDEX_1
ON LOTYPE
(LOTYPE);

-- OFFICELOテーブル
CREATE INDEX OFFICELO_INDEX_1
ON OFFICELO
(LOID);

-- OFFLINELOテーブル
CREATE INDEX OFFLINELO_INDEX_1
ON OFFLINELO
(LOID);

-- OL_AICCCOMMENTテーブル
CREATE INDEX OL_AICCCOMMENT_INDEX_1
ON OL_AICCCOMMENT
(USERID);

CREATE INDEX OL_AICCCOMMENT_INDEX_2
ON OL_AICCCOMMENT
(LOID);

-- OL_AICCCOREテーブル
CREATE INDEX OL_AICCCORE_INDEX_1
ON OL_AICCCORE
(USERID);

CREATE INDEX OL_AICCCORE_INDEX_2
ON OL_AICCCORE
(LOID);

-- OL_AICCINTERACTIONテーブル
CREATE INDEX OL_AICCINTERACTION_INDEX_1
ON OL_AICCINTERACTION
(USERID);

CREATE INDEX OL_AICCINTERACTION_INDEX_2
ON OL_AICCINTERACTION
(LOID);

-- OL_AICCOBJECTIVESテーブル
CREATE INDEX OL_AICCOBJECTIVES_INDEX_1
ON OL_AICCOBJECTIVES
(USERID);

CREATE INDEX OL_AICCOBJECTIVES_INDEX_2
ON OL_AICCOBJECTIVES
(LOID);

-- OL_SECTIONLOGテーブル
CREATE INDEX OL_SECTIONLOG_INDEX_1
ON OL_SECTIONLOG
(USERID);

CREATE INDEX OL_SECTIONLOG_INDEX_2
ON OL_SECTIONLOG
(LOID);

-- PEOPLEテーブル
CREATE INDEX People_Index_1
ON People
(user_id);

-- PERCEPTIONLOテーブル
CREATE INDEX PERCEPTIONLO_INDEX_1
ON PERCEPTIONLO
(LOID);

-- PROPAGATERELATIONテーブル
CREATE INDEX PropagateRelation_Index_1
ON PropagateRelation
(LOID);

-- PREREQUISITEテーブル
CREATE INDEX PREREQUISITE_INDEX_1
ON PREREQUISITE
(LOID);

-- ROLEテーブル
CREATE INDEX ROLES_INDEX_1
ON ROLES
(ROLEID);

-- ROLEASSIGNMENTSテーブル
CREATE INDEX ROLEASSIGNMENTS_INDEX_1
ON ROLEASSIGNMENTS
(USER_ID);

-- ROLESFUNCTIONテーブル
CREATE INDEX ROLESFUNCTION_INDEX_1
ON ROLESFUNCTION
(ROLEID);

-- SECTIONLOGテーブル
CREATE INDEX SECTIONLOG_INDEX_1
ON SECTIONLOG
(USERID);

CREATE INDEX SECTIONLOG_INDEX_2
ON SECTIONLOG
(LOID);

-- SMARTFORCELOテーブル
CREATE INDEX SMARTFORCELO_INDEX_1
ON SMARTFORCELO
(LOID);

-- SPSLOテーブル
CREATE INDEX SPSLO_INDEX_1
ON SPSLO
(LOID);

-- URLLOテーブル
CREATE INDEX URLLO_INDEX_1
ON URLLO
(LOID);

-- WBTLOテーブル
CREATE INDEX WBTLO_INDEX_1
ON WBTLO
(LOID);

-- XMOENTRYテーブル
CREATE INDEX XMOENTRY_INDEX_1
ON XMOENTRY
(XMO_ID);

-- SCORMLOテーブル
CREATE INDEX SCORMLO_INDEX_1 ON SCORMLO
(LOID);

-- SCORM_ATTEMPTテーブル
CREATE INDEX SCORMATTEMPT_INDEX_1 
ON SCORM_ATTEMPT
(USERID);

CREATE INDEX SCORMATTEMPT_INDEX_2 
ON SCORM_ATTEMPT
(LOID);

CREATE INDEX SCORMATTEMPT_INDEX_3 
ON SCORM_ATTEMPT
(STUDYSESSIONCOUNT);

CREATE INDEX SCORMATTEMPT_INDEX_4 
ON SCORM_ATTEMPT
(ACTIVITYID);

CREATE INDEX SCORMATTEMPT_INDEX_5 
ON SCORM_ATTEMPT
(ATTEMPTCOUNT);

CREATE INDEX SCORMATTEMPT_INDEX_6 
ON SCORM_ATTEMPT
(LEARNSESSIONCOUNT);

CREATE INDEX SCORMATTEMPT_INDEX_7 
ON SCORM_ATTEMPT
(SESSIONID);

-- SCORM_INTERACTIONテーブル
CREATE INDEX SCORMINTERACTION_INDEX_1 
ON SCORM_INTERACTION
(USERID);

CREATE INDEX SCORMINTERACTION_INDEX_2 
ON SCORM_INTERACTION
(LOID);

CREATE INDEX SCORMINTERACTION_INDEX_3 
ON SCORM_INTERACTION
(STUDYSESSIONCOUNT);

CREATE INDEX SCORMINTERACTION_INDEX_4 
ON SCORM_INTERACTION
(ACTIVITYID);

CREATE INDEX SCORMINTERACTION_INDEX_5 
ON SCORM_INTERACTION
(ATTEMPTCOUNT);

CREATE INDEX SCORMINTERACTION_INDEX_6 
ON SCORM_INTERACTION
(LEARNSESSIONCOUNT);

CREATE INDEX SCORMINTERACTION_INDEX_7 
ON SCORM_INTERACTION
(INTERACTIONCOUNT);

CREATE INDEX SCORMINTERACTION_INDEX_8 
ON SCORM_INTERACTION
(SESSIONID);

-- SCORM_LEARNERCOMMENTテーブル
CREATE INDEX SCORMLEARNERCOMMENT_INDEX_1 
ON SCORM_LEARNERCOMMENT
(USERID);

CREATE INDEX SCORMLEARNERCOMMENT_INDEX_2 
ON SCORM_LEARNERCOMMENT
(LOID);

CREATE INDEX SCORMLEARNERCOMMENT_INDEX_3 
ON SCORM_LEARNERCOMMENT
(STUDYSESSIONCOUNT);

CREATE INDEX SCORMLEARNERCOMMENT_INDEX_4 
ON SCORM_LEARNERCOMMENT
(ACTIVITYID);

CREATE INDEX SCORMLEARNERCOMMENT_INDEX_5 
ON SCORM_LEARNERCOMMENT
(ATTEMPTCOUNT);

CREATE INDEX SCORMLEARNERCOMMENT_INDEX_6 
ON SCORM_LEARNERCOMMENT
(LEARNSESSIONCOUNT);

CREATE INDEX SCORMLEARNERCOMMENT_INDEX_7 
ON SCORM_LEARNERCOMMENT
(LEARNERCOMMENTCOUNT);

CREATE INDEX SCORMLEARNERCOMMENT_INDEX_8 
ON SCORM_LEARNERCOMMENT
(SESSIONID);

-- SCORM_LMSCOMMENTテーブル
CREATE INDEX SCORMLMSCOMMENT_INDEX_1 
ON SCORM_LMSCOMMENT
(USERID);

CREATE INDEX SCORMLMSCOMMENT_INDEX_2 
ON SCORM_LMSCOMMENT
(LOID);

CREATE INDEX SCORMLMSCOMMENT_INDEX_3 
ON SCORM_LMSCOMMENT
(STUDYSESSIONCOUNT);

CREATE INDEX SCORMLMSCOMMENT_INDEX_4 
ON SCORM_LMSCOMMENT
(ACTIVITYID);

CREATE INDEX SCORMLMSCOMMENT_INDEX_5 
ON SCORM_LMSCOMMENT
(ATTEMPTCOUNT);

CREATE INDEX SCORMLMSCOMMENT_INDEX_6 
ON SCORM_LMSCOMMENT
(LEARNSESSIONCOUNT);

CREATE INDEX SCORMLMSCOMMENT_INDEX_7 
ON SCORM_LMSCOMMENT
(LMSCOMMENTCOUNT);

CREATE INDEX SCORMLMSCOMMENT_INDEX_8 
ON SCORM_LMSCOMMENT
(SESSIONID);

-- SCORM_OBJECTIVEテーブル
CREATE INDEX SCORMOBJECTIVE_INDEX_1 
ON SCORM_OBJECTIVE
(USERID);

CREATE INDEX SCORMOBJECTIVE_INDEX_2 
ON SCORM_OBJECTIVE
(LOID);

CREATE INDEX SCORMOBJECTIVE_INDEX_3 
ON SCORM_OBJECTIVE
(STUDYSESSIONCOUNT);

CREATE INDEX SCORMOBJECTIVE_INDEX_4 
ON SCORM_OBJECTIVE
(ACTIVITYID);

CREATE INDEX SCORMOBJECTIVE_INDEX_5 
ON SCORM_OBJECTIVE
(ATTEMPTCOUNT);

CREATE INDEX SCORMOBJECTIVE_INDEX_6 
ON SCORM_OBJECTIVE
(LEARNSESSIONCOUNT);

CREATE INDEX SCORMOBJECTIVE_INDEX_7 
ON SCORM_OBJECTIVE
(OBJECTIVECOUNT);

CREATE INDEX SCORMOBJECTIVE_INDEX_8 
ON SCORM_OBJECTIVE
(SESSIONID);

-- SCORMSESSIONテーブル
CREATE INDEX SCORMSESSION_INDEX_1 
ON SCORMSESSION
(USERID);

CREATE INDEX SCORMSESSION_INDEX_2 
ON SCORMSESSION
(LOID);

CREATE INDEX SCORMSESSION_INDEX_3 
ON SCORMSESSION
(STUDYSESSIONCOUNT);

CREATE INDEX SCORMSESSION_INDEX_4 
ON SCORMSESSION
(SESSIONID);